#ifndef __CADA_MOTOR_H__
#define __CADA_MOTOR_H__

#include "Arduino.h"


//io
//#define portA 2
//#define portB 3
#define pinH1A 2;  // drive MC6601
#define pinH1B 3;  // drive MC6601
#define pinH2A 5;  // drive MC6601
#define pinH2B 4;  // drive MC6601

//motor function.
#define FORWARD 1  //正转
#define BACKWARD 2 //反转
#define BRAKE 3  //刹车
#define RELEASE 0  //释放

#define portA 1
#define portB 2


class Motor
{
    public:
        //电机驱动函数
		Motor(); 							//电机默认IO初始化
        Motor(uint8_t _port); 				//电机端口初始化
        Motor(uint8_t _INA ,uint8_t _INB); 	//电机io初始化


        void begin(); //初始化
		void setMotorPort(uint8_t _port);	//电机端口初始化
        void setMotorDir(uint8_t dir);  	//设置电机方向，1为正转，2为反转
        void setMotorSpeed(uint8_t speed);  //单电机速度设置
        void setMotorMode(uint8_t cmd);  	//电机运行函数


        //电机驱动函数  
        void _cw(); //正转
        void _cw(uint8_t speed); //正转
        void _ccw(); //反转
        void _ccw(uint8_t speed); //反转
        void _brake();  //刹车
        void _release();  //释放

         //电机方向记录
        uint8_t _dir = 1;

        //电机速度记录
        uint8_t _speed = 128;

    private:
        //电机端口
        uint8_t _ina = pinH1A; //_ina = portA;
        uint8_t _inb = pinH1B; //_inb = portB;

};


#endif // __CADA_MOTOR_H__
