#include "CaDA_Robot.h"

Robot::Robot()
{

}



void Robot::begin(Motor *motorA, Motor *motorB)
{
    _motorA = motorA;
    _motorB = motorB;
    
    //_motorA->begin();
    //_motorB->begin();
	_motorA->setMotorPort(portA); //设置电机A端口
    _motorB->setMotorPort(portB); //设置电机B端口
    _motorA->setMotorDir(FORWARD); //设置电机A正转  FORWARD正转  BACKWARD  反转
    _motorB->setMotorDir(FORWARD); //设置电机B正转  FORWARD正转  BACKWARD  反转
    _motorA->setMotorSpeed(200); //设置电机B速度为128
    _motorB->setMotorSpeed(200); //设置电机A速度为128
	
    //获取电机库的速度
    _speedA = _motorA->_speed;
    _speedB = _motorB->_speed;
	

}






void Robot::goForward()
{
    _motorA->_cw();
    _motorB->_cw();
}

void Robot::goBackward()
{
    _motorA->_ccw();
    _motorB->_ccw();
}

void Robot::goLeft()
{
    _motorA->_cw();
    _motorB->_ccw();
}

void Robot::goRight()
{
    _motorA->_ccw();
    _motorB->_cw();
}



void Robot::goForward(int speedA, int speedB)
{
    _speedA = speedA;
    _speedB = speedB;
    goForward(_speedA, _speedB,0);
}
void Robot::goBackward(int speedA, int speedB)
{
    _speedA = speedA;
    _speedB = speedB;
    goBackward(_speedA, _speedB,0);
}
void Robot::goLeft(int speedA, int speedB)
{
    _speedA = speedA;
    _speedB = speedB;
    goLeft(_speedA, _speedB,0);
}
void Robot::goRight(int speedA, int speedB)
{
    _speedA = speedA;
    _speedB = speedB;
    goRight(_speedA, _speedB,0);
}


void Robot::goForward(uint32_t time)
{
    goForward(_speedA, _speedB,time);
}
void Robot::goBackward(uint32_t time)
{
    goBackward(_speedA, _speedB,time);
}
void Robot::goLeft(uint32_t time)
{
    goLeft(_speedA, _speedB,time);
}
void Robot::goRight(uint32_t time)
{
    goRight(_speedA, _speedB,time);
}

//全参数
void Robot::goForward(int speedA, int speedB, uint32_t time)
{
    _speedA = ~speedA;
    _speedB = ~speedB;

    _motorA->_cw(_speedA);
    _motorB->_cw(_speedB);
    if(time != 0)
    {
        delay(time);    //运行时间 单位ms
        _motorA->_release();
        _motorB->_release();
    }
}

void Robot::goBackward(int speedA, int speedB, uint32_t time)
{
    _speedA = ~speedA;
    _speedB = ~speedB;
    _motorA->_ccw(_speedA);
    _motorB->_ccw(_speedB);
    if(time != 0)
    {
        delay(time);    //运行时间 单位ms
        _motorA->_release();
        _motorB->_release();
    }
}

void Robot::goLeft(int speedA, int speedB, uint32_t time)
{
    _speedA = ~speedA;
    _speedB = ~speedB;
    _motorA->_cw(_speedA);
    _motorB->_ccw(_speedB);
    if(time != 0)
    {
        delay(time);    //运行时间 单位ms
        _motorA->_release();
        _motorB->_release();
    }
}


void Robot::goRight(int speedA, int speedB, uint32_t time)
{
    _speedA = ~speedA;
    _speedB = ~speedB;
    _motorA->_ccw(_speedA);
    _motorB->_cw(_speedB);
    if(time != 0)
    {
        delay(time);    //运行时间 单位ms
        _motorA->_release();
        _motorB->_release();
    }
}

void Robot::hold()
{
    _motorA->_brake();
    _motorB->_brake();
}

void Robot::stop()
{
    _motorA->_release();
    _motorB->_release();
}