#ifndef __CADA_ROBOT_H__
#define __CADA_ROBOT_H__

#include "Arduino.h"
#include "CaDA_Motor.h"

class Robot
{
    public:
        Robot();
        void begin(Motor *motorA, Motor *motorB);

        void goForward();
        void goBackward();
        void goLeft();
        void goRight();
        
        void goForward(int speedA, int speedB);	
	    void goBackward(int speedA, int speedB);
	    void goLeft(int speedA, int speedB);
	    void goRight(int speedA, int speedB);

        void goForward(uint32_t _time);
	    void goBackward(uint32_t _time);
	    void goLeft(uint32_t _time);
	    void goRight(uint32_t _time);
        //全参数
        void goForward(int speedA, int speedB, uint32_t _time);
        void goBackward(int speedA, int speedB, uint32_t _time);
        void goLeft(int speedA, int speedB, uint32_t _time);
        void goRight(int speedA, int speedB, uint32_t _time);


        void hold(); //brake，双电机
        void stop(); //电机端口操作为RELEASE，而不是brake
    private:
        Motor *_motorA;
        Motor *_motorB;
        
        uint16_t _speedA = 128;
        uint16_t _speedB = 128;

        

};

#endif
