#ifndef __CATURBOT_H__
#define __CATURBOT_H__

#include "Arduino.h"
#include "CaDA_Motor.h"
#include "CaDA_Robot.h"
#include "utility/pitches.h"
#include "Extensions/Buzzer.h"
#include "ServoPF.h"

#define pinPortAA 2 //MOS
#define pinPortAB 3
#define pinPortBA 5 //MOS
#define pinPortBB 4
#define pinPort1A 26 //IOS
#define pinPort1B 27
#define pinPort2A 29 //IOS
#define pinPort2B 28

#define pinBtnL 19
#define pinBtnR 25
#define pinLowP 21 //Low Power feedback
#define pinLEDG 20

#define FORWARD 1
#define BACKWARD 2
#define BRAKE 3
#define RELEASE 0

#define portA 1
#define portB 2
#define port1 3
#define port2 4

#define vAnalogReadLimit 120

void init();

void portWrite(uint8_t _io,bool _state);

void ledWrite(bool _state);

void portPWM(uint8_t _io,uint8_t _vPWM);

bool portRead(uint8_t _io);

bool btnRead(uint8_t _io);

int portData(uint8_t _io);

void portUSData(uint8_t _io);

void stopAll();

#endif